function [ES0_T,EL_L_T,EL,ES,roh]=Dynamic_solution(l,Es,El,Es_s,El_s,dz,dt,z,N,Q,iterationsNum,roh,A,Is_stationary)
% Here the dynamic equations are solved (equations (1a)-(1c) in the article)

globalize_vars;

%% initial conditions
if Is_stationary
    EL=El;
    ES=Es;
else
    EL=zeros(size(El));
    ES=zeros(size(Es));
    EL(1)=El(1);
    ES(end)=0;
    roh=1i*2*LAMBDA/GAMMAb*EL.*conj(ES)+wgn(1,N,Q/dt/dz,'complex','linear')*2/(GAMMAb);%2*sqrt(Q/dz)*(randn(1,N)+1i*randn(1,N))/(GAMMAb*sqrt(2))/sqrt(dt);
end;
I_L=2*n/Z0*A*abs(El_s).^2;
I_S=2*n/Z0*A*abs(Es_s).^2;       
ELnew=EL;
ESnew=ES;

ES0_T=zeros(1,iterationsNum); %Es(0,t) Stokes field in z=0
EL_L_T=ES0_T; %El(L,t) Stokes field in z=L 

%% Numerical Process

for index=1:iterationsNum
    ELz=(EL(2:end)-EL(1:end-1))/dz;
    ELnew(2:end)=EL(2:end)+dt*c/n*(-Alpha/2*EL(2:end)+1i*kappa*roh(2:end).*ES(2:end)-ELz);
    ESz=(ES(2:end)-ES(1:end-1))/dz;
    croh=conj(roh);
    ESnew(1:end-1)=ES(1:end-1)+dt*c/n*(-Alpha/2*ES(1:end-1)+1i*kappa*croh(1:end-1).*EL(1:end-1)+ESz);
    f = wgn(1,N,Q/dt/dz,'complex','linear');%f=sqrt(Q/dz)*(randn(1,N))/sqrt(dt);%sqrt(Q/dz)*(randn(1,N)+1i*randn(1,N))/sqrt(2)/sqrt(dt);
    rohNew=roh+dt*(1i*LAMBDA*EL.*conj(ES)+f-GAMMAb*roh/2);
        
    EL=ELnew;
    ES=ESnew;
    roh=rohNew;

% % %     Plotting the longitudial intensities for following the process
   if (mod(index,5000)==0)
        if G<Gth
            subplot(2,1,1);
            plot (z,2*n/Z0*A*abs(EL).^2/I_L(1));
                hold on
                plot(z,I_L/I_L(1),'r');
                legend('Dynamic','Steady State')
                hold off
            title(['Iteration Number:   ',num2str(index)])
            xlabel('z [m]'); ylabel('I_L [Watt]');
            subplot(2,1,2);
            plot (z,2*n/Z0*A*abs(ES).^2/I_L(1));
                I_S=2*n/Z0*A*abs(Es_s).^2;
                hold on
                plot(z,I_S/I_L(1),'r');
                legend('Dynamic','Steady State')
            ylabel('I_S [Watt]'); xlabel('z [m]');
        else
            plot (z,2*n/Z0*A*abs(EL).^2/I_L(1));
            hold all
            title(['Iteration Number:   ',num2str(index),' of ' num2str(iterationsNum)])
            xlabel('z [m]');    ylabel ('Optical Power, normlized by input power')
                plot(z,I_L/I_L(1));
                plot (z,2*n/Z0*A*abs(ES).^2/I_L(1));
                plot(z,I_S/I_L(1));
                legend('Pump Dynamic','Pump Steady State','Stokes Dynamic','Stokes Steady State')
            axis([-10*dz l+10*dz 0 1.5])
        end 
        hold off
        drawnow;      
    end
    

ES0_T(index)=ES(1);
EL_L_T(index)=EL(end);

end
 if G<Gth  
     subplot(2,1,1);
 end
 
title('Intensity distibution along the fiber');