function RF_spec (Z0,n,A,dt,EL_L_T,T,lim1,P0,L,windowSize,Trans)
%This function calculates the RF preiodogram of the Transfered\Reflected
%signal, (equation 2 in the article)

Resp=1;%0.55;                          %Photodetector responsitivity
R_analyzer=50;              %Spectrum analyzer resistance
N=length(T);
df=1/dt/N;
P_opt=A*2*n/Z0*(abs(EL_L_T)).^2;
P_opt=P_opt/1.13; %isolator's attunuation
V_electrical=Resp*P_opt*R_analyzer;
PSD_V=abs(fft(V_electrical)/N).^2/df/R_analyzer*1e3*2;
l=length(PSD_V);
f=df:df:df*l;
PSDlog=10*log10(filter(ones(1,windowSize)/windowSize,1,PSD_V));
semilogx(f((1+windowSize/2):floor(l/2))-windowSize/2*df,PSDlog((1+windowSize/2):floor(l/2)));
xlabel('Frequency[Hz]','fontname','Times New Roman','fontsize',22);
ylabel('PSD [dBm/Hz]','fontname','Times New Roman','fontsize',22);
if (Trans)
    title({'RF PSD, transfered signal ';['P0 = ', num2str(P0*1e3), 'mW  L = ',num2str(L/1e3),'Km']},'fontname','Times New Roman','fontsize',22)
else
    title({'RF PSD, Reflected signal ';['P0 = ', num2str(P0*1e3), 'mW  L = ',num2str(L/1e3),'Km']},'fontname','Times New Roman','fontsize',22)
end;
set(gca,'fontname','Times New Roman','fontsize',22)
xlim([1e3 lim1])
