function [IS,IL]=Steady_state_solution(P0,z,dz,g0,B,Alpha,A) 
%   Here the steady state equations are solved (equations 11 in R. B. Jenkins, R. M. Sova, and R. I. Joseph, Steady-State Noise Analysis of Spontaneous and Stimulated Brillouin
%   Scattering in Optical Fibers, IEEE J. Lightwave Technol. 25, 763770 (2007))

N=length(z);
IL=P0/A*ones(1,N);
IS=P0/A*ones(1,N);
R=0.5;
A1=R;
while abs (IS(end))>IL(1)*1e-15
    IS(1)=R*IL(1);
    A1=A1/2;
    for ind=1:N-1
        IL(ind+1)=IL(ind)-dz*(Alpha*IL(ind)+g0*IL(ind).*IS(ind)+B*sqrt(IL(ind).*IS(ind)));
        IS(ind+1)=IS(ind)-dz*(-Alpha*IS(ind)+g0*IL(ind).*IS(ind)+B*sqrt(IL(ind).*IS(ind)));
    end;
    if isreal(IS(end))
        R=R-A1;
    else
        R=R+A1;
    end; 
    IS=abs(IS);
    IL=abs(IL);
end;